//############################################################################//
//Made in 2010-2015 by Artyom Litvinovich
//############################################################################//   
char dec2bcd(char num){return((num/10*16)+(num%10));}
char bcd2dec(char num){return((num/16*10)+(num%16));}
//############################################################################//
void stri2(byte n,char *dst)
{
 byte digit;     
 
 digit='0';
 while(n>=10){
  digit++;
  n-=10;
 }
 
 dst[0]='0';
 if(digit!='0')dst[0]=digit;
 
 dst[1]='0'+n;
}
//############################################################################//
void stri3(word n,char *dst)
{
 word tmp;
 signed char i;
 word divider=100;
 
 for(i=3;i>0;i--){
  tmp=(n/divider)%10;
  divider/=10;
  if(tmp>0x09)tmp+=0x37;
         else tmp+=0x30;
  *dst++ =tmp;
 }
}
//############################################################################//
void stri5(word n,char *dst)
{
 byte tmp;
 signed char i;
 word divider=10000;
 
 for(i=5;i>0;i--){
  tmp=(n/divider)%10;
  divider/=10;
  if(tmp>0x09)tmp+=0x37;
         else tmp+=0x30;
  *dst++ =tmp;
 }
}
//############################################################################//
void stri10(long n,char *dst)
{
 byte tmp;
 signed char i;
 dword divider=100000000;
 
 for(i=10;i>0;i--){
  tmp=(n/divider)%10;
  divider/=10;
  if(tmp>0x09)tmp+=0x37;
         else tmp+=0x30;
  *dst++ =tmp;
 }
}
//############################################################################//
void strhex2(byte n,char *dst)
{
 byte i,e;
 
 for(i=0;i<2;i++){
  e=(n&0xF0)>>4;
  if(e<10)*dst='0'+e;else *dst='A'+e-10;
  dst++;
  n=n<<4;
 }
}
//############################################################################//
void strhex4(word n,char *dst)
{
 byte i,e;
 
 for(i=0;i<4;i++){
  e=(n&0xF000)>>12;
  if(e<10)*dst='0'+e;else *dst='A'+e-10;
  dst++;
  n=n<<4;
 }
}
//############################################################################//
void strhex8(dword n,char *dst)
{
 byte i,e;
 
 for(i=0;i<8;i++){
  e=(n&0xF0000000UL)>>28UL;
  if(e<10)*dst='0'+e;else *dst='A'+e-10;
  dst++;
  n=n<<4UL;
 }
}
//############################################################################//
//############################################################################//
typedef union{
 long	L;
 float	F;
}LF_t;
#define LEN	25
//############################################################################//
void xltoa(char *buf, unsigned long i, int base)
{
 char *s;
 int rem;
 char rev[LEN+1];
 
 if(i==0)s="0";else{
 	rev[LEN]=0;
 	s=&rev[LEN];
 	while(i){
 		rem=i % base;
 		if(rem<10)*--s=rem + '0';
 		else if(base==16) *--s="abcdef"[rem - 10];
 		i/=base;
 	}
 }
 strcpy(buf,s);
}
//############################################################################//
char *ftoa(float f)
	{
	long mantissa, int_part, frac_part;
	short exp2;
	LF_t x;
	char *p;
	static char outbuf[15];
	
	if (f==0.0)
		{
		outbuf[0]='0';
		outbuf[1]='.';
		outbuf[2]='0';
		outbuf[3]=0;
		return outbuf;
		}
	x.F=f;

    exp2=(unsigned char)(x.L >> 23) - 127;
    mantissa=(x.L & 0xFFFFFF) | 0x800000;
    frac_part=0;
    int_part=0;

 if (exp2 >= 31)return 0;
	else if (exp2 < -23)return 0;
    else if (exp2 >= 23)
      	int_part=mantissa << (exp2 - 23);
    else if (exp2 >= 0) 
		{
      	int_part=mantissa >> (23 - exp2);
      	frac_part=(mantissa << (exp2 + 1)) & 0xFFFFFF;
		}
    else // if (exp2 < 0)
      	frac_part=(mantissa  & 0xFFFFFF) >> -(exp2 + 1);

	p=outbuf;

	if (x.L < 0)
		*p++='-';

	if (int_part==0)
		*p++='0';
	else
		{
		xltoa(p, int_part, 10);
		while (*p)
			p++;
		}
	*p++='.';

	if (frac_part==0)
		*p++='0';
	else
		{
		char m, max;

		max=sizeof (outbuf) - (p - outbuf) - 1;
		if (max > 7)
			max=7;
		// print BCD
		for (m=0; m < max; m++)
			{
			// frac_part *= 10;
			frac_part=(frac_part << 3) + (frac_part << 1);    

			*p++=(frac_part >> 24) + '0';
			frac_part &= 0xFFFFFF;
			}
		// delete ending zeroes
		for (--p; p[0]=='0' && p[-1] != '.'; --p)
			;
		++p;
		}
	*p=0;

	return outbuf;
} 
//############################################################################//