//############################################################################//
//Made in 2010-2015 by Artyom Litvinovich
//############################################################################//   
#define twi_800_16 0x02
#define twi_400_16 0x0C
#define twi_100_16 0x48

#define twi_100_8 0x20
#define twi_400_8 0x02
#define twi_timeout 16

#define twi_wait word w=1000;while(w&&((TWCR&(1<<TWINT))==0))w--;
byte twi_def_speed;
//############################################################################//
void twi_speed(byte br){TWBR=br;}
//############################################################################//
void twi_init(byte br)
{
 TWSR=0x00;
 TWBR=br;
 TWCR=(1<<TWEN);
 twi_def_speed=br;
}
//############################################################################//
void twi_start(void)
{
 TWCR=(1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
 twi_wait;
}
//############################################################################//
void twi_stop(void){TWCR=(1<<TWINT)|(1<<TWSTO)|(1<<TWEN);}
byte twi_get_status(void){return TWSR&0xF8;}
//############################################################################//
void twi_write(byte data)
{
 TWDR=data;
 TWCR=(1<<TWINT)|(1<<TWEN);
 twi_wait;
}
//############################################################################//
byte twi_read_ack(void)
{
 TWCR=(1<<TWINT)|(1<<TWEN)|(1<<TWEA);
 twi_wait;
 return TWDR;
}
//############################################################################//
byte twi_read_nack(void)
{
 TWCR=(1<<TWINT)|(1<<TWEN);
 twi_wait;
 return TWDR;
}
//############################################################################//