@echo off
PATH=L:\soft\WinAVR\bin;L:\soft\WinAVR\utils\bin;%PATH%
rem set cff=-mmcu=atmega328p -I. -gdwarf-2 -Os -funsigned-char -funsigned-bitfields -fpack-struct -fshort-enums -Wall -Wstrict-prototypes -std=gnu99
    set cff=-mmcu=atmega328p -I. -std=gnu99 -W -Wall -pedantic -Wstrict-prototypes -Wundef -funsigned-char -funsigned-bitfields -ffunction-sections -fpack-struct -fshort-enums -ffreestanding -Os -g -gdwarf-2 --combine -fwhole-program -fno-inline-small-functions -fno-split-wide-types -fno-tree-scev-cprop -Wl,--relax,--gc-sections

del boot.hex

avr-gcc %cff% -Wl,--section-start=.text=0x7000 boot.c --output boot.elf -lm 2>gcc.log
avr-size boot.elf
avr-objcopy -O ihex -R .eeprom -R .fuse -R .lock -R .signature boot.elf boot.hex
avr-objcopy -j .eeprom --set-section-flags=.eeprom="alloc,load" --change-section-lma .eeprom=0 --no-change-warnings -O ihex boot.elf boot.eep || exit 0

del boot.elf boot.o boot.eep

pause