//############################################################################//
//Made in 2010-2015 by Artyom Litvinovich
//############################################################################//  
#define F_CPU 8300000UL
//############################################################################//  
#include <avr/eeprom.h> 
#include <avr/power.h>
#include <avr/sleep.h>
#include <util/delay.h> 
#include <util/crc16.h>
#include "avrlib/utils.h"
#include "avrlib/strval.h"
//############################################################################//
#define SPI_DDR     DDRB
#define SPI_PORT    PORTB
#define SPI_MOSI    3
#define SPI_MISO    4
#define SPI_SCK     5
//############################################################################//
#define LED_PORT  PORTD
#define LED_DDR   DDRD
#define LED_R     5
#define LED_G     6
//############################################################################//
#define PWR_DDR DDRB
#define PWR_PORT PORTB
#define PWR_PIN 1
//############################################################################//
byte fbuf[256+20];
//############################################################################//
#include "avrlib/serutil.h"
#include "avrlib/ser_tools.h"

#include "avrlib/twi_utils.h"
#include "avrlib/rtc.h"

#include "avrlib/vcam.h"
//############################################################################//
byte day,month,hour,minute,second;
word year;
//############################################################################//
#include "cam_fat.h"
#include "cam_pwr.h"
//############################################################################//
void rtc_get_date(void)
{
 byte n,s;
 
 n=rtc_read_page(0,rtc_data,&s);
 
 second=bcd2dec(rtc_data[0] & 0x7F);
 minute=bcd2dec(rtc_data[1] & 0x7F);
 hour  =bcd2dec(rtc_data[2] & 0x3F);
 
 day   =bcd2dec(rtc_data[4] & 0x3F);
 month =bcd2dec(rtc_data[5] & 0x1F);
 year  =2000+bcd2dec(rtc_data[6] & 0xFF);
}
//############################################################################//
void run_lapse(void)
{
 while(1){
  rtc_get_date();
  _delay_ms(100);
  sense_file();
  full_sleep(interval);
  _delay_ms(3000);
 }
}
//############################################################################//
int main(void)
{
 setup();
 
 //reinit_rtc();
 
 rtc_get_date();
 
 while (1){
  _delay_ms(500);
  if (card_init()) if (read_cfg_file()) if(the_cmd=='X')run_lapse();
  set_bit(LED_PORT,LED_R);
  _delay_ms(500);
  clear_bit(LED_PORT,LED_R);
 }
}
//############################################################################//  
